{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixos-unstable";
    flake-utils.url = "github:numtide/flake-utils";
  };
  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (
      system:
    let
      pkgs = import nixpkgs { inherit system; };
      bergamot-elm = import ./elm.nix {
        inherit (pkgs) lib stdenv;
	inherit (pkgs.elmPackages) fetchElmDeps elm;
	inherit (pkgs.nodePackages) uglify-js;
      };
    in
      {
        packages = { inherit bergamot-elm; };
        defaultPackage = bergamot-elm;
      }
    );
}
