module Bergamot.Utils exposing (..)

decodeStr : String -> String
decodeStr str =
    let
        go l =
            case l of
                '\\' :: '"' :: rest -> '"' :: go rest
                '\\' :: c :: rest -> c :: go rest
                c :: rest -> c :: go rest
                [] -> []
        noQuotes = String.dropLeft 1 <| String.dropRight 1 <| str
    in
        String.fromList (go (String.toList str))

encodeStr : String -> String
encodeStr s =
    let
        go l =
            case l of
                '\\' :: xs -> '\\' :: '\\' :: go xs
                '"' :: xs -> '\\' :: '"' :: go xs
                x :: xs -> x :: go xs
                [] -> []
    in
        String.fromList (go (String.toList s))

encodeLatex : String -> String
encodeLatex s =
    let
        go l =
            case l of
                '\\' :: xs -> String.toList "\\textbackslash " ++ go xs
                '{' :: xs -> '\\' :: '{' :: go xs
                '}' :: xs -> '\\' :: '}' :: go xs
                x :: xs -> x :: go xs
                [] -> []
    in
        String.fromList (go (String.toList s))

sequenceMaybes : List (Maybe a) -> Maybe (List a)
sequenceMaybes l =
    case l of
        [] -> Just []
        (Just x :: mxs) -> sequenceMaybes mxs |> Maybe.map (\xs -> x :: xs)
        _ -> Nothing
